function [F_DE,CR_DE,Pop_DE,DEmaxit,DEconvergCrit,neigDE] = calibrated_input(fname,Jkind,u_start,u_OPTGAME,SolutionMethod,player)
%define calibrated inputs for different models

%default
F_DE=0.5;
CR_DE=0.5;
Pop_DE=10; %# of control variables + 1
DEmaxit = 1000;
DEconvergCrit = [1.000001 0.5 100 0.5]; %criteria for convergence [1) e-tube for deviations between objective values, 2) critical % of population with nearly the same value 
%3) how many periods without improvement of objective value 4) critical % of population without improvement]

checkmodel=0; %check wheter a specified model is selected or default settings

%neigDE=[0.2 0.02 0.02]; %example for precpecified neigDe (SLOVNL)
%neigDE=[0.11 0.042 0.096]; %example for maxmin neigDe (SLOVNL)
neigDE=(max(u_start)-min(u_start))./(2*mean(u_start));%different deviations according to niveau of variable
for i=1:size(u_start,2);
    if  strcmpi(fname, 'slopol4') == 1                                     % (neigDE(i)==0) i.e. we apply to the entire slopol4
        neigDE(i)= max(u_start(:,i)-u_OPTGAME(:,i))/mean(u_start(:,i));
    end
end
% if  strcmpi(fname, 'mumod1') == 1
%     neigDE=(max(u_OPTGAME)-min(u_OPTGAME))./(2*mean(u_OPTGAME));    %different deviations according to niveau of OPTGAME solution
% end
for i=1:size(u_start,2);
    if  strcmpi(fname, 'mumod1') == 1                                     % (neigDE(i)==0) i.e. we apply to the entire slopol4
        neigDE(1,i)= min(u_OPTGAME(:,i));
        neigDE(2,i)= max(u_OPTGAME(:,i));
    end
end

%or

% for i=1:size(u_start,2);
%     neigDE(i)= max(u_start(:,i)-u_OPTGAME(:,i))/mean(u_start(:,i));
% end
if  strncmpi(fname, 'atopt',5) == 1   % (neigDE(i)==0)
    neigDE(i)= max(u_OPTGAME(:,i));
end
switch SolutionMethod
    case 'DE'
        if strcmpi(fname, 'slovnl') == 1
            if Jkind == 0
                F_DE=0.4;
                CR_DE=0.1;
                Pop_DE=10; %*state variables+1
                DEmaxit = 750;
                checkmodel=1;
            elseif Jkind == 1 || Jkind == 2
                F_DE=0.4;%6 4  9                               1.1
                CR_DE=0.9;%1 5 1                               0.1
                Pop_DE=50; %*state variables+1  10  20 60      50
                DEmaxit =2500;   % 750 1500  2000              2000
                checkmodel=1;
            end
        end
        
        if strncmpi(fname, 'atopt',5) == 1
            if Jkind == 0
                F_DE=0.4;
                CR_DE=0.1;
                Pop_DE=10; %*state variables+1
                DEmaxit = 750;
                checkmodel=1;
            elseif Jkind == 1 || Jkind == 2
                F_DE=0.4;%6 4  9                               1.1
                CR_DE=0.9;%1 5 1                               0.1
                Pop_DE=50; %*state variables+1  10  20 60      50
                DEmaxit =2500;   % 750 1500  2000              2000
                checkmodel=1;
            end
        end
        
        if strncmpi(fname, 'mumod',5) == 1
            if Jkind == 0
                F_DE=0.9;
                CR_DE=0.1;
                DEmaxit = 300;
                checkmodel=1;
            elseif Jkind == 1 || Jkind == 2
                F_DE=0.9;
                CR_DE=0.1;
                DEmaxit = 100;
                checkmodel=1;
            end
        end
         
    case 'DEstoch'
        if strcmpi(fname, 'slovnl') == 1
            if Jkind == 0
                F_DE=0.4;
                CR_DE=0.1; %0.1 
                Pop_DE=10; %*state variables+1: 10, 20, 30
                DEmaxit = 5; %750 1000 1500
                checkmodel=1;
            elseif Jkind == 1 || Jkind == 2
                F_DE=0.4;%6 4  9                               1.1
                CR_DE=0.9;%1 5 1                               0.1
                Pop_DE=10; %*state variables+1  10  20 60      50
                DEmaxit =5;   % 750 1500  2000              2000
                checkmodel=1;
            end
        end
        
        
end
if checkmodel==0
    disp('No model was selected in calibrated_input. Default settings are chosen.')
end