function [gsx,res,iter] = gs(fname,x0_t,xl_t,u_t,z_t,theta,eps,maxitGS,tol)
%      Gauss-Seidel iteration on system f(x) = b 
%      (specific to the model slovnl)
%      maxitGS -- number of iterations
%      x0 -- initial vector 

iter = 0;
gsx = x0_t;
fx = feval(fname,gsx,xl_t,u_t,z_t,theta,eps,0);
error=norm(gsx-fx);
test_fname=0;

if strcmpi(fname, 'slovnl') == 1
    while (error > tol) && (iter < maxitGS)
        gsx(1) = theta(1)*z_t(5) + theta(2) * xl_t(1) + theta(3) * (gsx(5)*(1 - u_t(1)/100)) + theta(4)*(gsx(4)-gsx(8)) + theta(5)*gsx(8) + eps(1);
        gsx(2) = theta(6)*z_t(5) + theta(7) * xl_t(2) + theta(8) * (gsx(6) - xl_t(6)) +theta(9)*(gsx(4)-gsx(8)) + theta(10)*gsx(8) + eps(2);
        gsx(3) = xl_t(3)+ theta(11) * (gsx(6) - xl_t(6)) + theta(12) * z_t(4) + eps(3);
        gsx(4) = theta(13) * xl_t(4) + theta(14) * ((u_t(3)/gsx(7))*100) + theta(15) * gsx(5) + eps(4);
        gsx(5) = gsx(1) + gsx(2) + u_t(2) + z_t(1) - gsx(3);
        gsx(6) = gsx(5) + gsx(3);
        gsx(7) = gsx(5) / gsx(6) * z_t(3) + gsx(3) / gsx(6) * z_t(2);
        gsx(8) = ((gsx(7) - xl_t(11)) / xl_t(11)) * 100;
        gsx(9) = xl_t(7);
        gsx(10) = xl_t(9);
        gsx(11) = xl_t(10);
        fx = feval(fname,gsx,xl_t,u_t,z_t,theta,eps,0);
        error = norm(gsx-fx);
        iter= iter + 1;
    end % while
    test_fname=1;
end
if strcmpi(fname, 'cons_game') == 1
    while (error > tol) && (iter < maxitGS)
        gsx(1) = (1 + theta(1))* (1 - xl_t(1)/(theta(2)*(1-theta(3)*xl_t(3))))*xl_t(1); %H
        gsx(2) = (1 + theta(4))* (1 - xl_t(2)/(theta(5)*xl_t(1)))*xl_t(2) + u_t(2); %S
        gsx(3) = theta(6)*(1+u_t(1))*gsx(1)^(theta(7))*gsx(2)^(1-theta(7)); %U     
        fx = feval(fname,gsx,xl_t,u_t,z_t,theta,eps,0);
        error = norm(gsx-fx);
        iter= iter + 1;
    end % while
    test_fname=1;
end
if strcmpi(fname, 'mumod1') == 1
    while (error > tol) && (iter < maxitGS)
        gsx(1) = u_t(1) - theta(15) / 2 * u_t(2) + theta(15) / 40 * gsx(13); %I1
        gsx(2) = u_t(1) - theta(16) / 2 * u_t(3) + theta(16) / 40 * gsx(14) + z_t(6); %I2
        gsx(3) = theta(2) * (gsx(8) - gsx(7)) - theta(4) * (gsx(5) - theta(1)) + theta(6) * gsx(4) - theta(17) * gsx(7) + theta(19) * xl_t(3) - theta(8) * u_t(2) + z_t(1); %y1_short
        gsx(4) = theta(3) * (gsx(7) - gsx(8)) - theta(5) * (gsx(6) - theta(1)) + theta(7) * gsx(3) - theta(18) * gsx(8) + theta(20) * xl_t(4) - theta(9) * u_t(3) + z_t(2); %y2_short
        gsx(5) = gsx(1) - gsx(9); %r1
        gsx(6) = gsx(2) - gsx(10); %r2
        gsx(7) = gsx(9) + theta(10) * gsx(3) + z_t(3); %pi1
        gsx(8) = gsx(10) + theta(11) * gsx(4) + z_t(4); %pi2
        gsx(9) = theta(12) * xl_t(7) + (1 - theta(12)) * xl_t(9); %pi1ex_tp
        gsx(10) = theta(13) * xl_t(8) + (1 - theta(13)) * xl_t(10); %pi2ex_tp
        gsx(11) = theta(14) * gsx(7) + (1 - theta(14)) * gsx(8); %piE
        gsx(12) = theta(14) * gsx(3) + (1 - theta(14)) * gsx(4); %yE
        gsx(13) = (100 + xl_t(15) - xl_t(9)) / 100 * xl_t(13) - u_t(2) + z_t(7); %D1
        gsx(14) = (100 + xl_t(16) - xl_t(10)) / 100 * xl_t(14) - u_t(3) + z_t(5); %D2
        gsx(15) = (xl_t(20) + xl_t(19) + xl_t(18) + xl_t(17) + xl_t(1) +gsx(1))/6; %BI1 (average I1 in t=-5:0)
        gsx(16) = (xl_t(24) + xl_t(23) + xl_t(22) + xl_t(21) + xl_t(2) +gsx(2))/6; %BI2 (average I2 in t=-5:0)
        gsx(17) = xl_t(1); %I1(-1)
        gsx(18) = xl_t(17); %I1(-2)
        gsx(19) = xl_t(18); %I1(-3)
        gsx(20) = xl_t(19); %I1(-4)
        gsx(21) = xl_t(2); %I2(-1)
        gsx(22) = xl_t(21); %I2(-2)
        gsx(23) = xl_t(22); %I2(-3)
        gsx(24) = xl_t(23); %I2(-4)
        fx = feval(fname,gsx,xl_t,u_t,z_t,theta,eps,0);
        error = norm(gsx-fx);
        iter= iter + 1;
    end % while
    test_fname=1;
end
if strcmpi(fname, 'slopol8') == 1
    while (error > tol) && (iter < maxitGS)
        gsx(1) = z_t(19) / z_t(15);
        %oileu_tr  = oil  / eu_tru_tsd
        gsx(2) = u_t(1) / gsx(49)  *100;
        %gr  = gn  / gdef  * 100
        gsx(3) = gsx(45) / gsx(46) * 100;
        %agwr  = agwn  / cpi  * 100
        gsx(4) = gsx(41) * gsx(50) / 100 - gsx(42) * gsx(51) / 100;
        %can  = exr  * expdef  / 100  - impr  * impdef  / 100
        gsx(5) = gsx(4) / gsx(27) * 100;
        %cagdp  = can  / gdpn  * 100
        gsx(6) = gsx(26) / xl_t(64) * 100 - 100;
        %grgdpr  = gdpr  / gdpr(-4)  * 100  - 100
        gsx(7) = (gsx(30) / xl_t(67) - 1) * 100;
        %grypot  = (ypot  / ypot(-4)  - 1)  * 100
        gsx(8) = gsx(26) / gsx(43) * 100;
        %prod  = gdpr  / emp  * 100
        gsx(9) = gsx(45) / gsx(8);
        %u_tlc  = agwn  / prod
        gsx(10) = gsx(44) - gsx(43);
        %u_tn  = lforce  - emp
        gsx(11) = gsx(10) / gsx(44) * 100;
        %u_tr  = u_tn  / lforce  * 100
        gsx(12) = gsx(37) + gsx(39) + gsx(2) + gsx(41);
        %demand  = invr  + cr  + gr  + exr
        gsx(13) = gsx(27) + u_t(2) - gsx(24) - gsx(23);
        %income  = gdpn  + transfersn  - inctax  - soctotal
        gsx(14) = gsx(13) / gsx(46) * 100;
        %incomer  = income  / cpi  * 100
        gsx(15) = (gsx(46) / xl_t(70) - 1) * 100;
        %infl  = (cpi  / cpi(-4)  - 1)  * 100
        gsx(16) = gsx(53) - gsx(15);
        %gov10yr  = gov10y  - infl
        gsx(17) = gsx(16) + 1.7;
        %u_tcc  = gov10yr  + 1.7
        gsx(18) = z_t(17) * (gsx(45) * gsx(43)/ 1000) /100;
        %inctaxpers  = inctaxrate  * (agwn  * emp  / 1000)  / 100
        gsx(19) = z_t(22) * (gsx(45) * gsx(43)/ 1000) /100;
        %socemp  = socemprate  * (agwn  * emp  / 1000)  / 100
        gsx(20) = gsx(45) * (z_t(17) / 100  + z_t(22) / 100);
        %wedge  = agwn  * ( inctaxrate  / 100  + socemprate  / 100)
        gsx(21) = gsx(45) - gsx(20);
        %netwagen  = agwn  - wedge
        gsx(22) = gsx(21) / gsx(46) * 100;
        %netwager  = netwagen  / cpi  * 100
        gsx(23) = gsx(55) + gsx(19);
        %soctotal  = soccomp  + socemp
        gsx(24) = gsx(18) + gsx(56);
        %inctax  = inctaxpers  + inctaxcorp
        gsx(25) = (1 - z_t(2) / 100)  * xl_t(25) + gsx(37);
        %capr  = (1  - depr  / 100)  * capr(-1)  + invr
        gsx(26) = gsx(39) + gsx(2) + gsx(37) + z_t(18) + gsx(41) - gsx(42);
        %gdpr  = cr  + gr  + invr  + inventr  + exr  - impr
        gsx(27) = gsx(26) * gsx(47) / 100;
        %gdpn  = gdpr  * gdpdef  / 100
        gsx(28) = gsx(39) * gsx(48) / 100;
        %cn  = cr  * cdef  / 100
        gsx(29) = gsx(44) * (1 - gsx(38) / 100);
        %trendemp  = lforce  * (1  - nairu_t  / 100)
        gsx(30) = exp(0.65 * log(gsx(29)) + (1 - 0.65) * log(gsx(25)) + log(z_t(23)));
        %log(ypot)  = 0.65  * log(trendemp)  + (1  - 0.65)  * log(capr)  + log(trendtfp)
        gsx(31) = gsx(26) / gsx(30) * 100;
        %u_ttil  = gdpr  / ypot  * 100
        gsx(32) = gsx(60) + gsx(23) + gsx(24) + gsx(57) - gsx(58) - z_t(16) - u_t(2) - gsx(59) - gsx(61);
        %balancen  = vat  + soctotal  + inctax  + revrest  - gnfin  - ginvn  - transfersn  - interest  - exprest
        gsx(33) = gsx(32) / gsx(27) * 100;
        %balancegdp  = balancen  / gdpn  * 100
        gsx(34) = xl_t(34) - gsx(32) + z_t(1);
        %debt  = debt(-1)  - balancen  + debtadj
        gsx(35) = gsx(34) / (gsx(27) + xl_t(27) + xl_t(71) + xl_t(72)) * 100;
        %debtgdp  = debt  / (gdpn  + gdpn(-1)  + gdpn(-2)  + gdpn(-3))  * 100
        gsx(36) = z_t(16) / gsx(47) * 100;
        %ginvr  = ginvn  / gdpdef  * 100
        gsx(37) = gsx(40) + gsx(36);
        %invr  = prinvr  + ginvr
        gsx(38) = xl_t(38) + theta(1)*z_t(28) + theta(2) * (xl_t(38) - gsx(74)) +  theta(3) * (gsx(74) - gsx(75)) + theta(4) * (gsx(75) - gsx(76)) + theta(5) * (gsx(76) - gsx(77)) + theta(6) * (gsx(77) - xl_t(77));
        %d(nairu_t) = @coegsx(1) +          @coegsx(2) * d(nairu_t(-1)) +       @coegsx(3) * d(nairu_t(-2)) +    @coegsx(4) * d(nairu_t(-3)) +    @coegsx(5) * d(nairu_t(-4)) +    @coegsx(6) * d(nairu_t(-5))
        gsx(39) = xl_t(39) * exp(theta(7)*z_t(28) + theta(8) *  log(xl_t(39) / xl_t(78)) + theta(9) *  log(gsx(14) / xl_t(14)) + theta(10) *  log(xl_t(39)) + theta(11) *  log(xl_t(14)) + theta(12) * gsx(16) + theta(13) * z_t(29));
        %log(cr / cr(-1)) =      @coegsx(1) +       @coegsx(2) * log(cr(-1) / cr(-2)) +       @coegsx(3) * log(incomer / incomer(-1)) + @coegsx(4) * log(cr(-1)) +       @coegsx(5) * log(incomer(-1)) +   @coegsx(6) * gov10yr + @coegsx(7) * @seas(1)
        gsx(40) = xl_t(40) * exp(theta(14)*z_t(28) + theta(15) *  log(xl_t(40) / xl_t(79)) + theta(16) *  log(gsx(12) / xl_t(12)) + theta(17) *  log(xl_t(40)) + theta(18) *  log(xl_t(12)) + theta(19) * xl_t(17) + theta(20) * z_t(14) + theta(21) * z_t(7));
        %log(prinvr / prinvr(-1)) = @coegsx(1) +     @coegsx(2) * log(prinvr(-1) / prinvr(-2)) + @coegsx(3) * log(demand / demand(-1)) +  @coegsx(4) * log(prinvr(-1)) +    @coegsx(5) * log(demand(-1)) +    @coegsx(6) * u_tcc(-1) + @coegsx(7) * du_tm992 + @coegsx(8) * du_tm024
        gsx(41) = xl_t(82) * exp(theta(22)*z_t(28) + theta(23) *  log(xl_t(41) / xl_t(83)) +  theta(24) *  log(z_t(25) / z_t(30)) +  theta(25) *  log(gsx(83)) +  theta(26) *  log(z_t(30)) +  theta(27) *  log(xl_t(86)) + theta(28) * z_t(8));
        %log(exr  / exr(-4))  = c(40)  +          c(41)  * log(exr(-1)  / exr(-5))  +       c(42)  * log(wtrade  / wtrade(-4))  +   c(43)  * log(exr(-4))  +        c(44)  * log(wtrade(-4))  +     c(45)  * log(reer(-4))  +       c(46)  * du_tm031
        gsx(42) = xl_t(89) * exp(theta(29)*z_t(28) + theta(30) *  log(gsx(54) / xl_t(86)) + theta(31) *  log(gsx(12) / xl_t(92)) + theta(32) *  log(xl_t(89)) + theta(33) *  log(xl_t(86)) + theta(34) *  log(xl_t(92)) + theta(35) *  z_t(11));
        %log(impr / impr(-4)) = @coegsx(1) +         @coegsx(2) * log(reer / reer(-4))       + @coegsx(3) * log(demand / demand(-4))   + @coegsx(4) * log(impr(-4))      + @coegsx(5) * log(reer(-4))      + @coegsx(6) * log(demand(-4))    + @coegsx(7) * du_tm052
        gsx(43) = xl_t(43) * exp(theta(36)*z_t(28) + theta(37) *  log(gsx(26) / xl_t(26)) + theta(38) *  log(xl_t(43)) +  theta(39) *  log(xl_t(26)) + theta(40) *  log(xl_t(9)) + theta(41) *  z_t(10) + theta(42) *  z_t(31));
        %log(emp / emp(-1)) = @coegsx(1) +           @coegsx(2) * log(gdpr / gdpr(-1))       + @coegsx(3) * log(emp(-1))       + @coegsx(4) * log(gdpr(-1))       + @coegsx(5) * log(u_tlc(-1))      + @coegsx(6) * du_tm051   + @coegsx(7) * @seas(2)
        gsx(44) = z_t(20) * (xl_t(44) / z_t(32) + theta(43)*z_t(28) +          theta(44) * (xl_t(44) / z_t(32) - xl_t(93) / z_t(33)) +                    theta(45) * (gsx(22) / xl_t(22)) +         theta(46) *z_t(3) +   theta(47) * z_t(8) + theta(48) * z_t(10));
        %(lforce / pop1564 - lforce(-1) / pop1564(-1)) = @coegsx(1) + @coegsx(2) * (lforce(-1) / pop1564(-1) - lforce(-2) / pop1564(-2)) + @coegsx(3) * (netwager / netwager(-1)) + @coegsx(4) * du_tm001 + @coegsx(5) * du_tm031 + @coegsx(6) * du_tm051
        gsx(45) = xl_t(96) * exp(theta(49)*z_t(28) + theta(50) * log(xl_t(45) / xl_t(97)) + theta(51) * log(xl_t(46) / xl_t(98)) + theta(52) * log(gsx(8) / xl_t(101)) + theta(53) * log(xl_t(94) / xl_t(68)) + theta(54) * (gsx(11) - gsx(38)));
        %log(agwn / agwn(-4)) = @coegsx(1)         + @coegsx(2) * log(agwn(-1) / agwn(-5))   + @coegsx(3) * log(cpi(-1) / cpi(-5))     + @coegsx(4) * log(prod / prod(-4))      + @coegsx(5) * log(agwn(-2) / cpi(-2))    + @coegsx(6) * (u_tr - nairu_t)
        gsx(46) = xl_t(70) * exp(theta(55)*z_t(28) + theta(56) * log(xl_t(46) / xl_t(98)) + theta(57) * log(gsx(9) / xl_t(104)) + theta(58) * log(gsx(1) / xl_t(107)) + theta(59) * log(gsx(31) / xl_t(110)) + theta(60) * log(xl_t(68)) + theta(61) * log(xl_t(102)) + theta(62) * z_t(14) + theta(63) * z_t(13));
        %log(cpi / cpi(-4)) = @coegsx(1)           + @coegsx(2) * log(cpi(-1) / cpi(-5))     + @coegsx(3) * log(u_tlc / u_tlc(-4))        + @coegsx(4) * log(oileu_tr / oileu_tr(-4))  + @coegsx(5) * log(u_ttil / u_ttil(-4))       + @coegsx(6) * log(cpi(-2))      + @coegsx(7) * log(u_tlc(-2))       + @coegsx(8) * du_tm992 + @coegsx(9) * du_tm07
        gsx(47) = xl_t(47) * exp(theta(64)*z_t(28) + theta(65) * log(gsx(46) / xl_t(46)) + theta(66) * log(xl_t(47)) + theta(67) * log(xl_t(46)) + theta(68) *  z_t(4) +  theta(69) * z_t(29));
        %log(gdpdef / gdpdegsx(-1)) = @coegsx(1)     + @coegsx(2) * log(cpi / cpi(-1))        + @coegsx(3) * log(gdpdegsx(-1))  +  @coegsx(4) * log(cpi(-1))      + @coegsx(5) * du_tm004 +  @coegsx(6) * @seas(1)
        gsx(48) = xl_t(48) * exp(theta(70)*z_t(28) + theta(71) * log(gsx(46) / xl_t(46)) + theta(72) * log(xl_t(48)) + theta(73) * log(xl_t(46)) + theta(74) * z_t(29));
        %log(cdef / cdegsx(-1)) = @coegsx(1)         + @coegsx(2) * log(cpi / cpi(-1))        + @coegsx(3) * log(cdegsx(-1))     + @coegsx(4) * log(cpi(-1)) +      @coegsx(5) * @seas(1)
        gsx(49) = xl_t(113) * exp(theta(75)*z_t(28) + theta(76) * log(xl_t(49) / xl_t(114)) + theta(77) * log(gsx(46) / xl_t(70)) +  theta(78) * log(xl_t(113)) + theta(79) * log(xl_t(70))); 
        %log(gdef / gdegsx(-4)) = @coegsx(1)          + @coegsx(2) * log(gdegsx(-1) / gdegsx(-5)) +    @coegsx(3) * log(cpi / cpi(-4))         + @coegsx(4) * log(gdegsx(-4))      + @coegsx(5) * log(cpi(-4))
        gsx(50) = xl_t(117) * exp(theta(80)*z_t(28) + theta(81) * log(xl_t(50) / xl_t(118)) +  theta(82) * log(xl_t(102) /xl_t(120)) + theta(83) * log(z_t(25) / z_t(30)) + theta(84) * log(xl_t(117)) + theta(85) * log(z_t(30)));
        %log(expdef  / expdegsx(-4))  = b(20)       + b(21)  * log(expdegsx(-1)  / expdegsx(-5))  + b(22)  * log(u_tlc(-2)  / u_tlc(-6))      +  b(23)  * log(wtrade  / wtrade(-4))  + b(24)  * log(expdegsx(-4))  +     b(25)  * log(wtrade(-4))
        gsx(51) = xl_t(123) * exp(theta(86)*z_t(28) + theta(87) * log(xl_t(51) / xl_t(124)) +  theta(88) * log(gsx(1) / xl_t(107)) + theta(89) * log(xl_t(123)) + theta(90) * log(xl_t(107)));
        %log(impdef / expdegsx(-4)) = @coegsx(1)      + @coegsx(2) * log(impdegsx(-1) / impdegsx(-5)) + @coegsx(3) * log(oileu_tr / oileu_tr(-4)) +  @coegsx(4) * log(impdegsx(-4))   +  @coegsx(5) * log(oileu_tr(-4))
        % corrected!!! log(impdef / impdegsx(-4)) = @coegsx(1) + @coegsx(2) * log(impdegsx(-1) / impdegsx(-5)) + @coegsx(3) * log(oileu_tr / oileu_tr(-4)) +  @coegsx(4) * log(impdegsx(-4))   +  @coegsx(5) * log(oileu_tr(-4))
        gsx(52) = xl_t(127) +             theta(91)* (xl_t(52) - xl_t(128)) +            theta(92) * (z_t(27) - z_t(34)) +    theta(93) * (xl_t(127) - z_t(34));
        %(sitbor3m - sitbor3m(-4)) = @coegsx(1) * (sitbor3m(-1) - sitbor3m(-5)) + @coegsx(2) * (eu_tr3m - eu_tr3m(-4)) + @coegsx(3) * (sitbor3m(-4) - eu_tr3m(-4))
        gsx(53) = xl_t(53) + theta(94)*z_t(28) +   theta(95) * (gsx(52) - xl_t(52)) +         theta(96) * (z_t(26) - z_t(35)) +      theta(97) * xl_t(53) +    theta(98) * xl_t(52) +      theta(99) * z_t(35);
        %(gov10y - gov10y(-1)) = @coegsx(1) + @coegsx(2) * (sitbor3m - sitbor3m(-1)) + @coegsx(3) * (eu_tr10y - eu_tr10y(-1)) + @coegsx(4) * gov10y(-1) + @coegsx(5) * sitbor3m(-1) + @coegsx(6) * eu_tr10y(-1)
        gsx(54) = xl_t(86) * exp(theta(100)*z_t(28) + theta(101) * log(xl_t(86) / xl_t(132)) + theta(102) * log(z_t(21) /z_t(36)) + theta(103) * log(z_t(15) / z_t(37)) + theta(104) * log(gsx(46) / xl_t(70)) + theta(105) * log(xl_t(86)) + theta(106) * log(z_t(36)) + theta(107) * log(z_t(37)) + theta(108) * log(xl_t(70)));
        %log(reer / reer(-4)) = @coegsx(1) +          @coegsx(2) * log(reer(-4) / reer(-8)) +     @coegsx(3) * log(siteu_tr / siteu_tr(-4)) + @coegsx(4) * log(eu_tru_tsd / eu_tru_tsd(-4)) +  @coegsx(5) * log(cpi / cpi(-4)) +         @coegsx(6) * log(reer(-4)) +      @coegsx(7) * log(siteu_tr(-4)) +   @coegsx(8) * log(eu_tru_tsd(-4)) +   @coegsx(9) * log(cpi(-4))
        gsx(55) = xl_t(135) * exp(theta(109)*z_t(28) + theta(110) * log(gsx(19) / xl_t(138)) + theta(111) * log(xl_t(135)) + theta(112) * log(xl_t(138)));
        %log(soccomp / soccomp(-4)) = @coegsx(1) +     @coegsx(2) * log(socemp / socemp(-4)) +    @coegsx(3) * log(soccomp(-4)) +    @coegsx(4) * log(socemp(-4))
        gsx(56) = xl_t(141) * exp(theta(113)*z_t(28) +    theta(114) *log(xl_t(56) / xl_t(142)) +          theta(115) *log(gsx(27) /xl_t(143)) + theta(116) *log(xl_t(141)) + theta(117) *log(xl_t(143)) + theta(118) * z_t(9) + theta(119) * z_t(12));
        % log(inctaxcorp / inctaxcorp(-4)) = @coegsx(1) + @coegsx(2) * log(inctaxcorp(-1) / inctaxcorp(-5)) + @coegsx(3) * log(gdpn / gdpn(-4)) +      @coegsx(4) * log(inctaxcorp(-4)) + @coegsx(5) * log(gdpn(-4)) +     @coegsx(6) * du_tm032 + @coegsx(7) * du_tm062
        gsx(57) = xl_t(57) * exp(theta(120)*z_t(28) + theta(121) *log(gsx(27) / xl_t(27)) + theta(122) * log(xl_t(57)) + theta(123) *log(xl_t(27)) + theta(124) *z_t(6));
        %log(revrest / revrest(-1)) = @coegsx(1) +    @coegsx(2) * log(gdpn / gdpn(-1)) +      @coegsx(3) * log(revrest(-1)) +   @coegsx(4) * log(gdpn(-1)) +     @coegsx(5) * du_tm021
        gsx(58) = xl_t(146) * exp(theta(125)*z_t(28) + theta(126) *log(xl_t(58) / xl_t(147)) +  theta(127) *log(u_t(1) / xl_t(154)) + theta(128) *log(xl_t(146) / xl_t(154))  + theta(129) * z_t(4));
        %log(gnfin  / gnfin(-4))  = c(201)          + c(202)  * log(gnfin(-1)  / gnfin(-5))  + c(203)  * log(gn  / gn(-4))     +    c(204)  * log(gnfin(-4)  / gn(-4))  +    c(205)  * du_tm004
        gsx(59) = xl_t(59) * exp(theta(130)*z_t(28) + theta(131) *log(xl_t(59) / xl_t(148)) +        theta(132) *log(gsx(34) * gsx(53) / xl_t(34) * xl_t(53)) + theta(133) *log(xl_t(59)) + theta(134) *log(xl_t(34) * xl_t(53)));
        %log(interest / interest(-1)) = @coegsx(1)    + @coegsx(2) * log(interest(-1) / interest(-2)) + @coegsx(3) * log(debt * gov10y / debt(-1) * gov10y(-1)) + @coegsx(4) * log(interest(-1)) + @coegsx(5) * log(debt(-1) * gov10y(-1))
        gsx(60) = xl_t(60) * exp(theta(135)*z_t(28) + theta(136) *log(xl_t(149) / xl_t(150)) + theta(137) * log((z_t(24) * gsx(28)) / (z_t(38) * xl_t(28))) +   theta(138) * log(xl_t(60)) + theta(139) * log(z_t(38) *xl_t(28)) +   theta(140) * z_t(3) + theta(141) * z_t(5) + theta(142) * z_t(6));
        %log(vat / vat(-1)) = @coegsx(1)            + @coegsx(2) * log(vat(-2) / vat(-3))       + @coegsx(3) * log((vataxrate * cn) / (vataxrate(-1) * cn(-1))) + @coegsx(4) * log(vat(-1)) +       @coegsx(5) * log(vataxrate(-1) * cn(-1)) + @coegsx(6) * du_tm001 + @coegsx(7) * du_tm011 + @coegsx(8) * du_tm021
        gsx(61) =xl_t(61) * exp(theta(143)*z_t(28) + theta(144) *log(xl_t(27) / xl_t(71)) + theta(145) *log(xl_t(71) / xl_t(72)) + theta(146) *log(xl_t(61)) + theta(147) *log(xl_t(27)) + theta(148) * z_t(29));
        %log(exprest / exprest(-1)) = @coegsx(1)   + @coegsx(2) * log(gdpn(-1) / gdpn(-2)) +   @coegsx(3) * log(gdpn(-2) / gdpn(-3)) +   @coegsx(4) * log(exprest(-1)) +  @coegsx(5) * log(gdpn(-1)) +     @coegsx(6) * @seas(1)
        gsx(62) = xl_t(26);
        gsx(63) = xl_t(62);
        gsx(64) = xl_t(63);
        gsx(65) = xl_t(30);
        gsx(66) = xl_t(65);
        gsx(67) = xl_t(66);
        gsx(68) = xl_t(46);
        gsx(69) = xl_t(68);
        gsx(70) = xl_t(69);
        gsx(71) = xl_t(27);
        gsx(72) = xl_t(71);
        gsx(73) = xl_t(38);
        gsx(74) = xl_t(73);
        gsx(75) = xl_t(74);
        gsx(76) = xl_t(75);
        gsx(77) = xl_t(76);
        gsx(78) = xl_t(39);
        gsx(79) = xl_t(40);
        gsx(80) = xl_t(41);
        gsx(81) = xl_t(80);
        gsx(82) = xl_t(81);
        gsx(83) = xl_t(82);
        gsx(84) = xl_t(54);
        gsx(85) = xl_t(84);
        gsx(86) = xl_t(85);
        gsx(87) = xl_t(42);
        gsx(88) = xl_t(87);
        gsx(89) = xl_t(88);
        gsx(90) = xl_t(12);
        gsx(91) = xl_t(90);
        gsx(92) = xl_t(91);
        gsx(93) = xl_t(44);           
        gsx(94) = xl_t(45);
        gsx(95) = xl_t(94);
        gsx(96) = xl_t(95);
        gsx(97) = xl_t(96);
        gsx(98) = xl_t(70);
        gsx(99) = xl_t(8);
        gsx(100) = xl_t(99);
        gsx(101) = xl_t(100);
        gsx(102) = xl_t(9);
        gsx(103) = xl_t(102);
        gsx(104) = xl_t(103);
        gsx(105) = xl_t(1);
        gsx(106) = xl_t(105);
        gsx(107) = xl_t(106);
        gsx(108) = xl_t(31);
        gsx(109) = xl_t(108);
        gsx(110) = xl_t(109);
        gsx(111) = xl_t(49);
        gsx(112) = xl_t(111);
        gsx(113) = xl_t(112);
        gsx(114) = xl_t(113);
        gsx(115) = xl_t(50);
        gsx(116) = xl_t(115);
        gsx(117) = xl_t(116);
        gsx(118) = xl_t(117);
        gsx(119) = xl_t(104);
        gsx(120) = xl_t(119);
        gsx(121) = xl_t(51);
        gsx(122) = xl_t(121);
        gsx(123) = xl_t(122);
        gsx(124) = xl_t(123);
        gsx(125) = xl_t(52);
        gsx(126) = xl_t(125);
        gsx(127) = xl_t(126);
        gsx(128) = xl_t(127);
        gsx(129) = xl_t(86);
        gsx(130) = xl_t(129);
        gsx(131) = xl_t(130);
        gsx(132) = xl_t(131);
        gsx(133) = xl_t(55);
        gsx(134) = xl_t(133);
        gsx(135) = xl_t(134);
        gsx(136) = xl_t(19);
        gsx(137) = xl_t(136);
        gsx(138) = xl_t(137);
        gsx(139) = xl_t(56);
        gsx(140) = xl_t(139);
        gsx(141) = xl_t(140);
        gsx(142) = xl_t(141);
        gsx(143) = xl_t(72);           
        gsx(144) = xl_t(58);
        gsx(145) = xl_t(144);
        gsx(146) = xl_t(145);
        gsx(147) = xl_t(146);
        gsx(148) = xl_t(59);
        gsx(149) = xl_t(60);
        gsx(150) = xl_t(149);
        gsx(151) = u_t(1);
        gsx(152) = xl_t(151);
        gsx(153) = xl_t(152);
        gsx(154) = xl_t(153);  

        fx = feval(fname,gsx,xl_t,u_t,z_t,theta,eps,0);
        error = norm(gsx-fx);
        iter= iter + 1;
    end % while
    test_fname=1;
end
if strcmpi(fname, 'slopol4') == 1
    while (error > tol) && (iter < maxitGS)
        gsx(1) = gsx(18) + gsx(31) + gsx(21) + gsx(19) - gsx(20);
        gsx(2) = (gsx(41) - u_t(3)) / gsx(24) * 100;
        gsx(3) = gsx(1) - gsx(2);
        gsx(4) = gsx(27) * gsx(24) / 100;
        gsx(5) = gsx(23) - gsx(22);
        gsx(6) = gsx(5) / gsx(23) * 100;
        gsx(7) = gsx(1) / gsx(22) * 100;
        gsx(8) = gsx(26) / gsx(24) * 100;
        gsx(9) = gsx(10) / gsx(24) * 100;
        gsx(10) = gsx(26) - gsx(38);
        gsx(11) = gsx(1) / gsx(30) * 100;
        gsx(12) = gsx(28) - gsx(36);
        gsx(13) = gsx(29) / gsx(16);
        gsx(14) = xl_t(14) * 0.965 + gsx(21);
        gsx(15) = gsx(1) + gsx(20);
        gsx(16) = gsx(24) / z_t(2);
        gsx(17) = u_t(4) - z_t(1);
        gsx(18) = theta(1)*z_t(11) + theta(2) * xl_t(18) + theta(3) * gsx(3) + theta(4) * z_t(7) + theta(5) * z_t(8) + theta(6) * z_t(9);
        gsx(19) = exp(theta(7) * z_t(11) + theta(8) * log(gsx(13)) + theta(9) * log(z_t(3)));
        gsx(20) = exp(theta(10) * z_t(11) + theta(11) * gsx(13) + theta(12) * log(gsx(15)));
        gsx(21) = exp(theta(13) * z_t(11) + theta(14) * log(xl_t(57)) + theta(15) * (log(gsx(15)) - log(xl_t(54))) + theta(16) * gsx(11) + theta(17) * gsx(12));
        gsx(22) = exp(theta(18) * z_t(11) + theta(19) * log(xl_t(22)) + theta(20) * log(gsx(15)) + theta(21) * log(gsx(8)));
        gsx(23) = exp(theta(22) * z_t(11) + theta(23) * log(xl_t(23)) + theta(24) * log(z_t(5)) + theta(25) * log(gsx(9)) + theta(26) * z_t(6));
        gsx(24) = exp(theta(27) * z_t(11) + theta(28) * log(gsx(26) / gsx(7)) + theta(29) * log(gsx(4)) + theta(30) * gsx(11) + theta(58) * log(z_t(10)) + theta(59) * log(gsx(29)));
        gsx(25) = exp(theta(31) * z_t(11) + theta(32) * log(xl_t(25)) + theta(33) * log(gsx(24)));
        gsx(26) = exp(theta(34) * z_t(11) + theta(35) * log(gsx(24)) + theta(36) * gsx(7) + theta(37) * (gsx(62) - xl_t(64)) + theta(38) * log(u_t(1)));
        gsx(27) = exp(theta(39) * z_t(11) + theta(40) * log(xl_t(27)) + theta(41) * log(gsx(1)) + theta(42) * u_t(4));
        gsx(28) = theta(43) * z_t(11) + theta(44) * xl_t(68) + theta(45) * u_t(4);
        gsx(29) = theta(46) * z_t(11) + theta(47) * xl_t(29) + theta(48) * gsx(16) + theta(49) * xl_t(65);
        gsx(30) = exp(theta(50) * z_t(11) + theta(51) * log(gsx(14)) + (1 - theta(51)) * log(gsx(45)) + theta(52) * z_t(4));
        gsx(31) = u_t(2) / gsx(25) * 100;
        gsx(32) = gsx(1) * gsx(25) / 100;
        gsx(33) = (gsx(19) - gsx(20)) * gsx(25) / 100;
        gsx(34) = gsx(33) / gsx(32) * 100;
        gsx(35) = gsx(1) / xl_t(48) * 100 - 100;
        gsx(36) = gsx(24) / xl_t(51) * 100 - 100;
        gsx(37) = gsx(4) / xl_t(71) * 100 - 100;
        gsx(38) = gsx(26) * u_t(1) / 100;
        gsx(39) = gsx(38) * gsx(22) / 1000;
        gsx(40) = theta(53) * z_t(11) + theta(54) * u_t(2) + theta(55) * u_t(3);
        gsx(41) = theta(56) * z_t(11) + theta(57) * gsx(39);
        gsx(42) = gsx(40) - gsx(41);
        gsx(43) = gsx(42) / gsx(32) * 100;
        gsx(44) = (gsx(61) + gsx(62) + gsx(63) + xl_t(63)) / 4;
        gsx(45) = gsx(23) * (1 - gsx(44) / 100);
        gsx(46) = xl_t(1);
        gsx(47) = xl_t(46);
        gsx(48) = xl_t(47);
        gsx(49) = xl_t(24);
        gsx(50) = xl_t(49);
        gsx(51) = xl_t(50);
        gsx(52) = xl_t(15);
        gsx(53) = xl_t(52);
        gsx(54) = xl_t(53);
        gsx(55) = xl_t(21);
        gsx(56) = xl_t(55);
        gsx(57) = xl_t(56);
        gsx(58) = xl_t(22);
        gsx(59) = xl_t(58);
        gsx(60) = xl_t(59);
        gsx(61) = xl_t(6);
        gsx(62) = xl_t(61);
        gsx(63) = xl_t(62);
        gsx(64) = xl_t(44);
        gsx(65) = xl_t(17);
        gsx(66) = xl_t(28);
        gsx(67) = xl_t(66);
        gsx(68) = xl_t(67);
        gsx(69) = xl_t(4);
        gsx(70) = xl_t(69);
        gsx(71) = xl_t(70);
        
        fx = feval(fname,gsx,xl_t,u_t,z_t,theta,eps,0);
        error = norm(gsx-fx);
        iter= iter + 1;
    end
    test_fname=1;
end
if test_fname==0
    disp(['Gauss-Seidel solution is not defined for this model!'])
end
res = norm(gsx-fx);

