function [label_time] = subplot_results(fname,x,u,x_names,u_names,plotMethod,numPM,list_objectives,PlotType)
close;
if strcmpi(fname, 'slovnl') == 1
    label_time={'04q1','04q2','04q3','04q4','05q1','05q2','05q3','05q4','06q1','06q2','06q3','06q4'};
    label_range=1:1:12;
end

if strcmpi(fname, 'slopol4') == 1
    label_time={'','2002','','','','2003','','','','2004','','','','2005','','','','2006','','','','2007','',''};
    label_range=1:1:24;
end

if strcmpi(fname, 'slopol8') == 1
    label_time={'','2008','','','','2009','','','','2010','','','','2011','','','','2012','','','','2013','','','','2014','','','','2015','',''};
    label_range=1:1:32;
end

if strcmpi(fname, 'mumod1') == 1
    %sr = 6; sc = 2; %subplot dimension for states
    sr=ceil(size(x_names,2)/2); sc = 2; %subplot dimension for states
    cr = 3; cc = 1; %subplot dimension for controls
    label_time=1:1:30;
    label_range=1:1:30;
end

if strcmpi(fname, 'cons_game') == 1
    sr = 3; sc = 1; %subplot dimension for states
    cr = 2; cc = 1; %subplot dimension for controls
    label_time=1:1:10;
    label_range=1:1:10;
end

for i=1:size(u_names,2)
    subplot(cr,cc,i);
    grid on
    grid(gca);
    set(gca,'YGrid','on');
    j=1;
    plot(u(:,i,j),':bx', 'MarkerSize',7);hold on;
    j=j+1;
    if j<=numPM
        plot(u(:,i,j),'-rs', 'MarkerSize',5);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(u(:,i,j),'--kd', 'MarkerSize',6);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(u(:,i,j),'-.g*', 'MarkerSize',6);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(u(:,i,j),'-mo', 'MarkerSize',5);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(u(:,i,j),':cp', 'MarkerSize',5);hold on;
        j=j+1;
    end
    xlim([1 size(label_range,2)]);
    ylabel(u_names(i));
    xlabel('time');
    set(gca,'XTick',label_range);
    set(gca,'XTickLabel',label_time);
    h = legend(plotMethod,4);
    set(h,'Interpreter','none','FontSize',6);
end
pause

for i=1:size(x_names,2)
    subplot(sr,sc,i);
    grid on
    grid(gca);
    set(gca,'YGrid','on');
    j=1;
    plot(x(:,i,j),':bx', 'MarkerSize',7);hold on;
    j=j+1;
    if j<=numPM
        plot(x(:,i,j),'-rs', 'MarkerSize',5);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(x(:,i,j),'--kd', 'MarkerSize',6);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(x(:,i,j),'-.g*', 'MarkerSize',6);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(x(:,i,j),'-mo', 'MarkerSize',5);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(x(:,i,j),':cp', 'MarkerSize',5);hold on;
        j=j+1;
    end
    xlim([1 size(label_range,2)]);
    ylabel(x_names(i));
    xlabel('time');
    set(gca,'XTick',label_range);
    set(gca,'XTickLabel',label_time);
    h = legend(plotMethod,4);
    set(h,'Interpreter','none','FontSize',6);
end
pause
close;

if PlotType==2% if subplots only
    return
end
for i=1:size(u_names,2)
    %subplot(cr,cc,i);
    grid on
    grid(gca);
    set(gca,'YGrid','on');
    j=1;
    plot(u(:,i,j),':bx', 'MarkerSize',7);hold on;
    j=j+1;
    if j<=numPM
        plot(u(:,i,j),'-rs', 'MarkerSize',5);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(u(:,i,j),'--kd', 'MarkerSize',6);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(u(:,i,j),'-.g*', 'MarkerSize',6);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(u(:,i,j),'-mo', 'MarkerSize',5);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(u(:,i,j),':cp', 'MarkerSize',5);hold on;
        j=j+1;
    end
    xlim([1 size(label_range,2)]);
    ylabel(u_names(i));
    xlabel('time');
    set(gca,'XTick',label_range);
    set(gca,'XTickLabel',label_time);
    h = legend(plotMethod,4);
    set(h,'Interpreter','none','FontSize',6);
    pause
    close;
end


for i=1:size(x_names,2)
    %subplot(sr,sc,i);
    grid on
    grid(gca);
    set(gca,'YGrid','on');
    j=1;
    plot(x(:,i,j),':bx', 'MarkerSize',7);hold on;
    j=j+1;
    if j<=numPM
        plot(x(:,i,j),'-rs', 'MarkerSize',5);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(x(:,i,j),'--kd', 'MarkerSize',6);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(x(:,i,j),'-.g*', 'MarkerSize',6);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(x(:,i,j),'-mo', 'MarkerSize',5);hold on;
        j=j+1;
    end
    if j<=numPM
        plot(x(:,i,j),':cp', 'MarkerSize',5);hold on;
        j=j+1;
    end
    xlim([1 size(label_range,2)]);
    ylabel(x_names(i));
    xlabel('time');
    set(gca,'XTick',label_range);
    set(gca,'XTickLabel',label_time);
    h = legend(plotMethod,4);
    set(h,'Interpreter','none','FontSize',6);
    pause
    close;
end

